# 快速操作[](#快速操作 "Permalink")

版本历史

*   在[GitLab 12.1 中](https://gitlab.com/gitlab-org/gitlab-foss/-/merge_requests/26672)引入：一旦执行了一项操作，成功执行快速操作后将显示一条警报.
*   在[GitLab 13.2](https://gitlab.com/gitlab-org/gitlab/-/issues/16877)和更高版本中，您可以在更新问题，史诗和合并请求的描述时使用快速操作.

快速操作是针对问题，史诗，合并请求和提交的常见操作的文本快捷方式，通常可通过在 GitLab 用户界面中单击按钮或下拉菜单来完成. 您可以在说明中或问题，史诗，合并请求和提交的注释中输入这些命令. 每个命令应放在单独的行上，以便正确检测和执行.

## Quick Actions for issues, merge requests and epics[](#quick-actions-for-issues-merge-requests-and-epics "Permalink")

以下快速操作适用于其中的描述，讨论和主题：

*   Issues
*   合并要求
*   Epics

| Command | Issue | 合并要求 | Epic | Action |
| --- | --- | --- | --- | --- |
| `/approve` |   | ✓ |   | 批准合并请求. |
| `/assign @user` | ✓ | ✓ |   | 分配一个用户. |
| `/assign @user1 @user2` | ✓ | ✓ |   | 分配多个用户. |
| `/assign me` | ✓ | ✓ |   | 分配自己. |
| `/award :emoji:` | ✓ | ✓ | ✓ | 切换表情符号奖. |
| `/child_epic <epic>` |   |   | ✓ | 将子史诗添加到`<epic>` . `<epic>`值的格式应为`&epic` ， `group&epic`或`group&epic`的 URL（ [在 GitLab 12.0 中引入](https://gitlab.com/gitlab-org/gitlab/-/issues/7330) ）. |
| `/clear_weight` | ✓ |   |   | 净重. |
| `/close` | ✓ | ✓ | ✓ | Close. |
| `/confidential` | ✓ |   |   | 保密. |
| `/copy_metadata <!merge_request>` | ✓ | ✓ |   | 从项目中的另一个合并请求中复制标签和里程碑. |
| `/copy_metadata <#issue>` | ✓ | ✓ |   | Copy labels and milestone from another issue in the project. |
| `/create_merge_request <branch name>` | ✓ |   |   | 从当前问题开始创建一个新的合并请求. |
| `/done` | ✓ | ✓ | ✓ | 将待办事项标记为已完成. |
| `/due <date>` | ✓ |   |   | 设置截止日期. 有效的`<date>`示例包括`in 2 days` （ `this Friday`和`December 31st` . |
| `/duplicate <#issue>` | ✓ |   |   | 关闭此问题，并将其标记为另一个问题的副本. 另外，将两者都标记为相关. |
| `/epic <epic>` | ✓ |   |   | 添加到史诗`<epic>` . `<epic>`值的格式应为`&epic` ， `group&epic`或`group&epic`的 URL. |
| `/estimate <<W>w <DD>d <hh>h <mm>m>` | ✓ | ✓ |   | 设置时间估计. 例如， `/estimate 1w 3d 2h 14m` . |
| `/iteration *iteration:iteration` | ✓ |   |   | 设置迭代（ [在 GitLab 13.1 中引入](https://gitlab.com/gitlab-org/gitlab/-/issues/196795) ） |
| `/label ~label1 ~label2` | ✓ | ✓ | ✓ | 添加一个或多个标签. 标签名称也可以不使用波浪号（ `~` ）开头，但是不支持混合语法. |
| `/lock` | ✓ | ✓ |   | 锁定螺纹. |
| `/merge` |   | ✓ |   | 合并更改. 根据项目设置，这可能是[管道成功](merge_requests/merge_when_pipeline_succeeds.html) ，添加到" [合并火车](../../ci/merge_request_pipelines/pipelines_for_merged_results/merge_trains/index.html) "等时. |
| `/milestone %milestone` | ✓ | ✓ |   | 设定里程碑. |
| `/move <path/to/project>` | ✓ |   |   | 将此问题移到另一个项目. |
| `/parent_epic <epic>` |   |   | ✓ | 将父级史诗设置为`<epic>` . `<epic>`值的格式应为`&epic` ， `group&epic`或`group&epic`的 URL（ [在 GitLab 12.1 中引入](https://gitlab.com/gitlab-org/gitlab/-/issues/10556) ）. |
| `/promote` | ✓ |   |   | 将问题升级为史诗. |
| `/publish` | ✓ |   |   | 将问题发布到关联的[状态页](status_page/index.html) （ [在 GitLab 13.0 中引入](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/30906) ） |
| `/reassign @user1 @user2` | ✓ | ✓ |   | 更改受让人. |
| `/relabel ~label1 ~label2` | ✓ | ✓ | ✓ | 用指定的标签替换现有的标签. |
| `/relate #issue1 #issue2` | ✓ |   |   | 将问题标记为相关. |
| `/remove_child_epic <epic>` |   |   | ✓ | 从`<epic>`删除儿童史诗. `<epic>`值的格式应为`&epic` ， `group&epic`或`group&epic`的 URL（ [在 GitLab 12.0 中引入](https://gitlab.com/gitlab-org/gitlab/-/issues/7330) ）. |
| `/remove_due_date` | ✓ |   |   | 删除到期日. |
| `/remove_epic` | ✓ |   |   | 从史诗中删除. |
| `/remove_estimate` | ✓ | ✓ |   | 删除时间估计. |
| `/remove_iteration` | ✓ |   |   | 删除迭代（ [在 GitLab 13.1 中引入](https://gitlab.com/gitlab-org/gitlab/-/issues/196795) ） |
| `/remove_milestone` | ✓ | ✓ |   | 删除里程碑. |
| `/remove_parent_epic` |   |   | ✓ | 从史诗中删除父史诗（ [在 GitLab 12.1 中引入](https://gitlab.com/gitlab-org/gitlab/-/issues/10556) ）. |
| `/remove_time_spent` | ✓ | ✓ |   | 消除花费的时间. |
| `/remove_zoom` | ✓ |   |   | 从此问题中删除 Zoom 会议（ [在 GitLab 12.4 中引入](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/16609) ）. |
| `/reopen` | ✓ | ✓ | ✓ | Reopen. |
| `/shrug <comment>` | ✓ | ✓ | ✓ | 将注释附加到`¯\＿(ツ)＿/¯` . |
| `/spend <time(-<h>h <mm>m)> <date(<YYYY-MM-DD>)>` | ✓ | ✓ |   | 减去花费的时间. （可选）指定花费时间的日期. 例如`/spend time(-1h 30m)`或`/spend time(-1h 30m) date(2018-08-26)` . |
| `/spend <time(<h>h <mm>m)> <date(<YYYY-MM-DD>)>` | ✓ | ✓ |   | 增加花费的时间. （可选）指定花费时间的日期. 例如`/spend time(1h 30m)`或`/spend time(1h 30m) date(2018-08-26)` . |
| `/submit_review` |   | ✓ |   | Submit a pending review ([introduced in GitLab 12.7](https://gitlab.com/gitlab-org/gitlab/-/issues/8041)). |
| `/subscribe` | ✓ | ✓ | ✓ | 订阅通知. |
| `/tableflip <comment>` | ✓ | ✓ | ✓ | 在`(╯°□°)╯︵ ┻━┻`添加注释. |
| `/target_branch <local branch name>` |   | ✓ |   | 设置目标分支. |
| `/title <new title>` | ✓ | ✓ | ✓ | 更改标题. |
| `/todo` | ✓ | ✓ | ✓ | 添加待办事项. |
| `/unassign @user1 @user2` | ✓ | ✓ |   | 删除特定的受让人. |
| `/unassign` | ✓ | ✓ |   | 删除所有受让人. |
| `/unlabel ~label1 ~label2` or `/remove_label ~label1 ~label2` | ✓ | ✓ | ✓ | 删除所有或特定标签. |
| `/unlock` | ✓ | ✓ |   | 解锁线程. |
| `/unsubscribe` | ✓ | ✓ | ✓ | 退订通知. |
| `/weight <value>` | ✓ |   |   | 设定重量. 为有效选项`<value>`包括`0` ， `1` ， `2` ，依此类推. |
| `/wip` |   | ✓ |   | 切换"进行中"状态. |
| `/zoom <Zoom URL>` | ✓ |   |   | 将 Zoom [Meeting](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/16609)添加到此问题（ [在 GitLab 12.4 中引入](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/16609) ）. |

## Autocomplete characters[](#autocomplete-characters "Permalink")

许多快速操作都需要一个参数，例如：用户名，里程碑和标签. 与从列表中选择项目相比， [自动完成字符](autocomplete_characters.html)可以使输入参数更加容易.

## Quick actions parameters[](#quick-actions-parameters "Permalink")

设置快速操作参数的最简单方法是使用自动完成功能. 如果您手动输入参数，则该参数必须用双引号（ `"` ）括起来，除非它仅包含以下字符：

1.  ASCII 字母.
2.  数字（0-9）.
3.  下划线（ `_` ），连字符（ `-` ），问号（ `?` ），点（ `.` ）或`&` （ `&` ）.

参数也区分大小写. 自动完成功能会自动处理此问题，并自动插入引号.

## Quick actions for commit messages[](#quick-actions-for-commit-messages "Permalink")

以下快速操作适用于提交消息：

| Command | Action |
| --- | --- |
| `/tag v1.2.3 <message>` | 使用可选消息标记此提交 |